import {Event, Queueable, ShouldQueue} from '../../types'
import {uuid4} from '../../../../util'

/**
 * Event fired before an item is pushed to the queue.
 */
export class PushingToQueue<T extends ShouldQueue<Queueable>> implements Event {
    public readonly eventName = '@extollo/lib.PushingToQueue'

    public readonly eventUuid = uuid4()

    public readonly shouldBroadcast = true

    constructor(
        public readonly item: T,
        public readonly queueName: string,
    ) {}
}
